define('ns', [],
	function(){
		var global = {
			name : '__global__',
			parent: {},
			scope:[],
			children:[],
			path: '/',
			key: ''
		};
		function NS(namespace, parent, num){
			var exist, 
          overlay = num < 0;
      
      num = overlay ? ~num : num;

			if(parent && (parent instanceof NS) && (exist = parent.children.filter(
				function(e){
					return e.uid == parent.uid+(namespace?'.'+namespace+(num!==undefined?'.'+num:''):'')
				}
			)[0])) return exist;
			else if(parent && (typeof parent == 'string')){//Если parent строка рекурсивно превращаем его в NS
				parent.split('.').forEach(function(e,i,a){
					parent  = !/\d+/.test(e)
						    ? new NS(e,
									parent instanceof NS
										? parent
										: undefined,
									/\d+/.test(a[i+1])
										? a[i+1]
										: undefined)
						    : parent;
				})
			}
			
			if (!namespace) { return parent || global; }

			this.name = namespace, 																//Short name of ns
			this.key = (parent&&(parent.key+'.')||'')+namespace,								//Long identifier of ns level
			this.uid = (parent&&(parent.uid+'.')||'')+namespace+(num!==undefined?'.'+num:''), 	//Unique id of ns
			this.parent = parent, 																//Link to parent Namespace object 
			this.children = [], 																//Array of links to childrens namespaces
			this.global = global, 																//Root Namespace object with scope of all other namespaces
			this.num = overlay || typeof num == 'string'
               ? num
               : parent
                 ? parent.num != null
                   ? parent.num
                   : num
                 : num, 					//Optional key, used in some modules as identifier of coprocessor
			this.cache = {} 																	//Collection of collections of unique in current ns objects 			
			this.parent && this.parent.children.push(this);
			global.scope.push(this);			
		}
		return NS;
})